hdu 1690 Bus System 最短路 Floyd算法。。INF一定要很大很大。。。数据类型用long long。

Bus System

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)

Total Submission(s): 7163    Accepted Submission(s): 1853

Problem Description

Because of the huge population of China, public transportation is very important. Bus is an important transportation method in traditional public transportation system. And it’s still playing an important role even now.

The bus system of City X is quite strange. Unlike other city’s system, the cost of ticket is calculated based on the distance between the two stations. Here is a list which describes the relationship between the distance and the cost.

Your neighbor is a person who is a really miser. He asked you to help him to calculate the minimum cost between the two stations he listed. Can you solve this problem for him?

To simplify this problem, you can assume that all the stations are located on a straight line. We use x-coordinates to describe the stations’ positions.

Input

The input consists of several test cases. There is a single number above all, the number of cases. There are no more than 20 cases.

Each case contains eight integers on the first line, which are L1, L2, L3, L4, C1, C2, C3, C4, each number is non-negative and not larger than 1,000,000,000. You can also assume that L1<=L2<=L3<=L4.

Two integers, n and m, are given next, representing the number of the stations and questions. Each of the next n lines contains one integer, representing the x-coordinate of the ith station. Each of the next m lines contains two integers, representing the start
point and the destination.

In all of the questions, the start point will be different from the destination.

For each case,2<=N<=100,0<=M<=500, each x-coordinate is between -1,000,000,000 and 1,000,000,000, and no two x-coordinates will have the same value.

Output

For each question, if the two stations are attainable, print the minimum cost between them. Otherwise, print “Station X and station Y are not attainable.” Use the format in the sample.

Sample Input

2
1 2 3 4 1 3 5 7
4 2
1
2
3
4
1 4
4 1
1 2 3 4 1 3 5 7
4 1
1
2
3
10
1 4

Sample Output

Case 1:
The minimum cost between station 1 and station 4 is 3.
The minimum cost between station 4 and station 1 is 3.
Case 2:
Station 1 and station 4 are not attainable.

数据类型用long long。INF设置成千亿最好,,我百亿貌似都WA了。

还有输入输出用%I64d。。。

剩下的就是Floyd干的事了。

代码:

#include <stdio.h>
#include <limits.h>
#define INF 110000000000
typedef long long ll ;
ll graph[110][110] , p[110];
//bool visited[110] ;
ll min(ll a , ll b)
{
	return a>b?b:a ;
}
void floyd(int n)
{
	for(int k = 1 ; k <= n ; ++k)
	{
		for(int i = 1 ; i <= n ; ++i)
		{
			for(int j = 1 ; j <= n ; ++j)
			{
				graph[i][j] = min(graph[i][j],graph[i][k]+graph[k][j]) ;
			}
		}
	}
}

int main()
{
	int t , c = 1;
	scanf("%d",&t) ;
	while(t--)
	{
		ll l1,l2,l3,l4,c1,c2,c3,c4 ;
		scanf("%I64d%I64d%I64d%I64d%I64d%I64d%I64d%I64d",&l1,&l2,&l3,&l4,&c1,&c2,&c3,&c4) ;
		int n , m ;
		scanf("%d%d",&n,&m) ;
		for(int i = 1 ; i <= n ; ++i)
		{
			scanf("%I64d",&p[i]) ;
		}
		for(int i = 1 ; i <= n ; ++i)
		{
			graph[i][i] = 0 ;
			for(int j = 1 ; j < i ; ++j)
			{
				ll dis = p[i]-p[j] ;
				dis = dis>0?dis:-dis ;
				if(dis<=l1)
				{
					graph[i][j] = graph[j][i] = c1 ;
				}
				else if(dis<=l2)
				{
					graph[i][j] = graph[j][i] = c2 ;
				}
				else if(dis<=l3)
				{
					graph[i][j] = graph[j][i] = c3 ;
				}
				else if(dis<=l4)
				{
					graph[i][j] = graph[j][i] = c4 ;
				}
				else
				{
					graph[i][j] = graph[j][i] = INF ;
				}
			}
		}
		floyd(n) ;
		printf("Case %d:\n",c++) ;
		for(int i = 0 ; i < m ; ++i)
		{
			int s , t ;
			scanf("%d%d",&s,&t) ;
			if(graph[s][t] >= INF)
			{
				printf("Station %d and station %d are not attainable.\n",s,t) ;
			}
			else
			{
				printf("The minimum cost between station %d and station %d is %I64d.\n",s,t,graph[s][t]) ;
			}
		}
	}
	return 0 ;
}

与君共勉

时间: 2024-08-26 06:12:32

hdu 1690 Bus System 最短路 Floyd算法。。INF一定要很大很大。。。数据类型用long long。的相关文章

hdu 1690 Bus System(最短路)

问题: 链接:点击打开链接 题意: 思路: 代码: #include <iostream> #include <cstdio> #include <cstring> using namespace std; #define INF 1000000000000 typedef __int64 LL; const int N = 110; __int64 dis[N][N],place[N]; __int64 L1,L2,L3,L4,C1,C2,C3,C4; int n,m

hdu 1690 Bus System(Floyd)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1690 Problem Description Because of the huge population of China, public transportation is very important. Bus is an important transportation method in traditional public transportation system. And it's

hdu 1690 Bus System(Dijkstra最短路)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1690 Bus System Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 6569    Accepted Submission(s): 1692 Problem Description Because of the huge popula

hdu 1690 Bus System (最短路径)

Bus System Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 6082    Accepted Submission(s): 1560 Problem Description Because of the huge population of China, public transportation is very importa

HDU 1690 Bus System 任意点最短路径Floyd

原题: http://acm.hdu.edu.cn/showproblem.php?pid=1690 题目大意: 图中的表是代表不同长度路径的花费,输入所有点的坐标,求任意两点间的最短花费. 因为是求任意两点,这里最好是用floyd算法. 题中几大坑: 数据可能会超int,要用long long int: 坐标可以为负,求距离要用abs绝对值函数. 参考代码如下: #include <iostream> #include"iostream" #include"st

hdu 1690 Bus System

floyd算法.这题目比较操蛋,首先INF需要比较大,我选择了INF = 0xffffffffffffff.还有一点就是%lld会挂掉的,用%I64d才能AC. #include<cstdio> #include<cmath> #include<cstring> #include<algorithm> using namespace std; const int maxn = 105; __int64 INF = 0xffffffffffffff; __in

杭电 ACM HDU 1217 Arbitrage(最短路 floyd算法)

Arbitrage Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 5272    Accepted Submission(s): 2418 Problem Description Arbitrage is the use of discrepancies in currency exchange rates to transform

hdu 1960 Bus System

Bus System Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 6166    Accepted Submission(s): 1580 Problem Description Because of the huge population of China, public transportation is very importa

HDU 2066 最短路floyd算法+优化

http://acm.hdu.edu.cn/showproblem.php?pid=206 题意 从任意一个邻居家出发 到达任意一个终点的 最小距离 解析 求多源最短路 我想到的是Floyd算法 但是题目给出的n的大小不确定 所以图很稀疏 会有很多孤立点 会多跑很多没用的路径 需要优化一下 不然会超时 我看其他人很多都是用迪杰斯特拉写的,可以试试 AC代码 1 #include <stdio.h> 2 #include <math.h> 3 #include <string.